#ifndef _INCLUDES_
#define _INCLUDES_

#ifdef _ADK_

typedef unsigned int DWORD;
typedef unsigned short WORD;
typedef unsigned char BYTE;
typedef long long __int64;
typedef unsigned long long __uint64;
typedef int __int32;
typedef unsigned int __uint32;
typedef short __int16;
typedef char __int8;
typedef int BOOL;

#define _GNU_SOURCE

#include <stdlib.h>
#include <ctype.h>
#include <stdio.h>
#include <string.h>
#include <sys/time.h>
#include <unistd.h>

#define _strlwr(foo) { char *i = foo; while (*i) *i++ = tolower(*i); }
#define strnicmp strncasecmp
#define stricmp strcasecmp
#define _stricmp strcasecmp
#define _strnicmp strncasecmp
#define _fcloseall fcloseall

#else

#include <windows.h>
#include <stdio.h>
#include <conio.h>
//#include <iostream.h>
//#include <string.h>

#endif

#ifdef _DEBUG	//on DEBUG support a debug stream
	#include <fstream.h>
	extern ofstream ofdbg;
	#define dbgout(txt) /*if(ofdbg.is_open()) ofdbg << txt;*/
	#define dbgout2(txt) /*if(ofdbg.is_open()) ofdbg << txt;*/
#else
	#define dbgout(txt)
	#define dbgout2(txt)
#endif

#endif
