MESSAGE	"PS2 Printf sample for ASM5900 v1.3b"
			; 
			; PS2 Printf
			; Coded by Duke / Napalm
			; 23/03-2001
			;

			; to support asm5900 v1.8b u need...
			TARGET BIN, R5900

				
			INCLUDE	"elfhead.asm"


code		SEGMENT	400000h
		
			INCLUDE	"macros.asm"
			INCLUDE	"dmalib.asm"
			INCLUDE	"gslib.asm"
			INCLUDE	"printf.asm"
	
main		PROC	;ALIGN 4 is default

			addi	sp,sp,-200h
			
			ei
			jal	@DmaReset
			nop
			lui	a1,0
			li	a2,1		;	change to 2 for NTSC
			li	a3,1
			jal	@Init_GS
			nop
	
			jal	@SetVideoMode
			nop
			jal	@Dma02Wait
			nop
			la	a2,@setup_scr
	
			li	v0,1000a000h
				
			li	v1,15
			sw	v1,DMA02SIZE(v0)
			sw	a2,DMA02ADR(v0)
			li	v1,101h
			sw	v1,DMA02CH(v0)
			li	a0,2
			li	v1,64h
			syscall
			nop		
	
			print	@my_text
			dumpreg	s0
			locate	100,110
			ffcolor	0FF0000h	; set font color to BLUE (B,G,R)
			print	@my_text1
			dumpreg	s1
			locate	100,120
			ffcolor	0FFh
			print	@my_text2
			dumpreg	s2
			ffcolor	0FF00h
			fbcolor	0FFh
			locate	120,150
			print	@my_text3
			
hmm:			j	@hmm
			nop

main			ENDP


			; t0 = reg to convert to -> reg buffer (ascii(hex))

reg2ascii		PROC
			la	a0,@reg_buffer
			li	t2,8
r2a_loop:		andi	t1,t0,0Fh
			addi	at,t1,-9
			blez	at,@less_than_a
			nop
			addiu	t1,t1,7
less_than_a:		addiu	t1,t1,48
			sb	t1,7(a0)
			addi	a0,a0,-1
			srl	t0,t0,4
			addi	t2,t2,-1
			bne	t2,zero,@r2a_loop
			nop
			jr	ra
			nop

reg2ascii		ENDP

			;DATA starts here
			
			ALIGN	8
reg_buffer:		DD	0
			DB	0

my_text:		DB	"s0 = 0x",0
my_text1:		DB	"s1 = 0x",0
my_text2:		DB	"s2 = 0x",0
my_text3:		DB	"Printf macro version",0
MESSAGE "main: is located at addr : 0x",@main
MESSAGE "printf: is located at addr : 0x",@printf
code			ENDS