MESSAGE "dmalib file included!"
;
; NPM_DMA library ver 0.2
; for asm5900 assembler
;
; (c) Duke /Napalm 2001
;

; DMA registers
DEFINE		DMA02CH		= 00h
DEFINE		DMA02ADR	= 10h
DEFINE		DMA02SIZE	= 20h
DEFINE		DMA02TAG	= 30h

			
Dma02Wait	PROC	ALIGN 8
		
			li	v0,1000A000h
waitloop:		lw	v1,DMA02CH(v0)
			andi	v1,v1,100h
			bne	v1,zero,@waitloop
			nop
			jr	ra
			nop

Dma02Wait	ENDP

			
SendPrim	PROC	ALIGN 8

			li	v0,1000A000h
			sw	a0,DMA02TAG(v0)
			sw	zero,DMA02SIZE(v0)
			lwu	v1,DMA02CH(v0)
			ori	v1,v1,105h
			sw	v1,DMA02CH(v0)	
			jr	ra
			nop

SendPrim	ENDP
	

DmaReset	PROC	ALIGN 8

			li	v0,1000A000h
			sw	zero,80h(v0)
			sw	zero,00h(v0)
			sw	zero,30h(v0)
			sw	zero,10h(v0)
			sw	zero,50h(v0)
			sw	zero,40h(v0)
			li	v1,0FF1Fh
			sw	v1,0E010h-0A000h(v0)
			lw	v1,0E010h-0A000h(v0)
			andi	v1,v1,0FF1Fh
			sw	v1,0E010h-0A000h(v0)
			sw	zero,0E000h-0A000h(v0)
			sw	zero,0E020h-0A000h(v0)
			sw	zero,0E030h-0A000h(v0)
			sw	zero,0E050h-0A000h(v0)
			sw	zero,0E040h-0A000h(v0)
			lw	v1,0E000h-0A000h(v0)
			ori	v1,v1,1
			sw	v1,0E000h-0A000h(v0)
			jr	ra
			nop

DmaReset	ENDP